/*
 * Construct.c
 *   A workaround for compilers without cast-constructors. Construction is done with a 
 * cast constructor in TIGCC/GCC, or with these functions (much slower) anywhere else.
 * Speed only matters on the calc, so nothing is lost this way.
 *
 */

#include "crogue.h"

#ifndef CASTCONSTRUCT

//{{{
coord construct_coord(uchar x, uchar y)
{
	coord c;
	
	c.x = x; c.y=y;
	return c;
}
//}}}
//{{{
COORD construct_wincoord(int x, int y)
{
	COORD c;
	
	c.X = x; c.Y = y;
	return c;
}
//}}}
//{{{
direction construct_direction(schar x, schar y)
{
	direction d;
	
	d.x = x;
	d.y = y;
	
	return d;
}
//}}}
//{{{
range construct_range(uchar max, uchar min)
{
	range r;
	
	r.max = max;
	r.min = min;
	
	return r;
}
//}}}


#endif
