#include "crogue.h"

#define NUM_HELPPAGES 2

#define HELP_REFERENCE_START 0
#define HELP_REFERENCE_LENGTH 21
#define HELP_ABOUT_START (HELP_REFERENCE_START+HELP_REFERENCE_LENGTH)
#define HELP_ABOUT_LENGTH 19

#define NUM_HELPLINES (HELP_REFERENCE_LENGTH + HELP_ABOUT_LENGTH)

const char* help_titles[NUM_HELPPAGES] = {
	"Quick reference",
	"About"
	};

const char* help_content[NUM_HELPLINES] = {
	"1-9: Walk",
	"Arrows: Scroll view",
	"0: Up/down stair",
	"ON: Save",
	"STO: Pick up",
	"|: Inventory",
	"(: Wear/wield item",
	"): Drop item",
	"X: Fire readied ammo",
	"Y: Cast a spell",
	"Z: Use item",
	"T: Take off item",
	"+: Close door",
	"-: Open door",
	"/: Throw/fire item",
	"^: Search",
	"CATALOG: List discoveries",
	"ESC: Quit",
	"",
	"F1: Help",
	"F2: Player stats",
	
	"CalcRogue",
	"by Jim Babcock",
	CROGUE_VERSION,
	"",
	"This game is postcardware. If you enjoy it,",
	"please send the author a postcard at the",
	"address below from wherever you live. Feel",
	"free to include feature requests and your",
	"e-mail address.",
	"",
	"  Jim Babcock",
	"  16 Sweeney Ridge Rd",
	"  Bedford, Massachusetts",
	"  01730",
	"",
	"This program is released under the GNU",
	"General Public License (GPL). Source is",
	"available at http://www.gis.net/~wssddc/",
	"jimmy_b/crogue_source.zip."
};

const int help_offsets[NUM_HELPPAGES] = {
	HELP_REFERENCE_START,
	HELP_ABOUT_START
	};
const int help_lengths[NUM_HELPPAGES] = {
	HELP_REFERENCE_LENGTH,
	HELP_ABOUT_LENGTH
	};

static int currentpage = 0;

void helptitlebynum(int N, char *buf)
{
	strcpy(buf, help_titles[N]);
}

void helpline(int N, char *buf)
{
	strcpy(buf, *(help_content + N + help_offsets[currentpage]));
}

void help(void)
{
	currentpage = UI_Menu_Pick( COORD(7,14), COORD(142, 79), NUM_HELPPAGES, &helptitlebynum, 0);
	
	if(currentpage==-1) {
		UI_TF_FullRedraw(&w->tilefield);
		return;
	}
	
	UI_Menu_Pick( COORD(0,0), COORD(159, 99), help_lengths[currentpage], &helpline, 1);
	UI_TF_FullRedraw(&w->tilefield);
}

