typedef struct dungeondesc
{
	uchar num_rooms;
	uchar num_holes;
} dungeondesc;

typedef struct cavedesc
{
	uchar light_chance;
} cavedesc;

typedef struct pregenmapdesc
{
	uint globallight;
	uchar tiles[MAPSIZE_Y][MAPSIZE_X];
} pregenmapdesc;

typedef struct spec_descriptor
{
	uint type;
	coord location;
	uint destmap;
	coord destcoord;
} spec_descriptor;

typedef enum {
	map_dungeon = 1,
	map_cave,
	map_pregen
} map_gen_method_types;

typedef union map_gen_method_ext
{
	dungeondesc dungeon;
	cavedesc cave;
	pregenmapdesc pregen;
} map_gen_method_ext;

typedef struct map_gen_method
{
	uint type;
	map_gen_method_ext ext;
} map_gen_method;

typedef struct mapdesc
{
	filelink name;
	filelink monstertab;
	filelink genmethod;
	uint flags;
	uint difficulty;
	uint numspecial;
	filelink special;
} mapdesc;

#define MAPFLAG_NORANDMONST 1



// Mkmap.c
void init_map(coord size);
void reinit_map(coord size);
void cleanup_map(void);

void place_player_on_map(int source, coord pos);
void gen_map(int source, coord pos);


