enum
{
	LIGHTING_UNEXPLORED = 0,
	LIGHTING_DARK,
	LIGHTING_LIT,
	LIGHTING_UNINITIALIZED
};

void UI_MF_clear(void);
void UI_MF_sendmsg(const char *msg);
void UI_MF_wait(void);

int UI_CharWidth(char c);
int UI_StringWidth(char *str);


typedef struct
{
	uchar tile;
	uchar lighting;
} UI_TF_TileInfo;

typedef struct
{
	// Properties (set at initialization)
	coord pos;
	coord size, window;
	const uchar *graphics;
	uchar tileheight, tilewidth;
	
	// Data (changes with use)
	UI_TF_TileInfo **tiles;
	coord viewoffset;
	
} UI_Tilefield;

void UI_TF_MoveCamera(UI_Tilefield *tf, int x, int y);
void UI_TF_PlaceCamera(UI_Tilefield *tf, int x, int y);
void UI_TF_Scroll(UI_Tilefield *tf, int x, int y);

int  UI_TF_Init(UI_Tilefield *tf, coord pos, coord size, coord window, const uchar *graphics, uchar tileheight, uchar tilewidth);
void UI_TF_Deinit(UI_Tilefield *tf);
void UI_TF_PutTile(UI_Tilefield *tf, int x, int y, uchar tnum, uchar lighting);
void UI_TF_FullRedraw(UI_Tilefield *tf);


int UI_Menu_Pick( coord pos, coord size, int numchoices, void (*getchoice)(int N, char *buf), int viewonly );


void help(void);
