typedef struct filelink
{
	uchar flags;
	uchar file;
	uint offset;
} filelink;
#define PTRFLAG_JUMPTABLE  1
#define PTRFLAG_SHUFFLETAB 2

extern const filelink filelink_null;


void catprintf(char *target, const char *format, ...);

void init_shuffle_tab(void);

const void *deref_file_ptr(filelink p);
filelink deref_file_ptr_partial(filelink p);
filelink deref_jump_table(const char *table);

ushort tracevision(register sshort x1, register sshort y1, register sshort x2, register sshort y2);
					// Returns whether there is an unobstructed path between
					// the points. Tests may not be symmetrical.
coord trace_path(int x, int y, direction dir, int distance);
void illuminate(int x, int y, int radiussquared);
#define distancesquare(x1, y1, x2, y2) ( (x1-x2)*(x1-x2) + (y1-y2)*(y1-y2) )
uchar xrandom(uint range);
//#define RANGE(a,b) rrandom((range){b, a})
#define RANGE(a,b) xrandom( ((a)<<8)+(b) )	// Better to pass as high and low bytes of one arg because most calls
uchar rrandom(range r);
sint nrandom(uint max, uint min);
char *pluralize(const char *str);

void Black_ClrScr(void);
void Black_DrawChar (short x, short y, char c, short Attr);
void Black_DrawStr(short x, short y, const char *str, short Attr);
#ifdef IS_CALCULATOR
void Black_ScrRectFill(const SCR_RECT *rect, const SCR_RECT *clip, short Attr);
void Black_DrawLine(short x0, short y0, short x1, short y1, short Attr);
#endif

#ifdef REALCOMPUTER
#	ifdef min // Some platforms provide dangerous versions of this
#		undef min
#	endif
	int min(int a, int b);
#	ifdef max
#		undef max
#	endif
	int max(int a, int b);
#endif

